#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, g;
    cin >> n >> m >> g;
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
    }
    cout << 0 << "\n1";
}
/*


 */